#include <GL/glut.h>    /* includes gl.h, glu.h */

#include <stdio.h>

/*  Function Prototypes  */

GLvoid  initgfx( GLvoid );
GLvoid  keyboard( GLubyte, GLint, GLint );
GLvoid  drawScene( GLvoid );


void printHelp( char * );

/* Global Definitions */

#define KEY_ESC        27      /* ascii value for the escape key */

static GLint angle = 30;
void
main( int argc, char *argv[] )
{
   GLsizei width, height;

   glutInit( &argc, argv );

   width = glutGet( GLUT_SCREEN_WIDTH ); 
   height = glutGet( GLUT_SCREEN_HEIGHT );
   glutInitWindowPosition( width /4, height / 4 );
   glutInitWindowSize( width / 2, height / 2 );
   glutInitDisplayMode( GLUT_RGBA );
   glutCreateWindow( argv[0] );

   initgfx();

   glutKeyboardFunc( keyboard );
   glutDisplayFunc( drawScene ); 

   printHelp( argv[0] );

   glMatrixMode( GL_PROJECTION );
   glOrtho(-2.0,2.0,-2.0,2.0,2.0,-2.0);
   glMatrixMode( GL_MODELVIEW );

   glutMainLoop();
}

void
printHelp( char *progname )
{
   fprintf(stdout, 
           "\n%s - demonstrates use of matrix modes and stacks\n\n"
		   "Space bar          - rotate\n\n"
           "Escape Key         - exit the program\n\n",
           progname);
}

GLvoid
initgfx( GLvoid )
{
   glClearColor( 0.0, 0.0, 0.0, 1.0 );
   glShadeModel( GL_FLAT );
}

GLvoid 
keyboard( GLubyte key, GLint x, GLint y )
{
   switch (key) {
   case ' ':
		angle += 10;
		if(angle == 360)
			angle = 0;
		glutPostRedisplay();
		break;
	case KEY_ESC:   /* Exit whenever the Escape key is pressed */
       exit(0);
   }
}

GLvoid
XYaxes()
{
   glBegin( GL_LINES );
	   glColor3f( 1.0, 0.0, 0.0 );
       glVertex3f( 0.0, 0.0,0.0 );
       glVertex3f( 0.5, 0.0,0.0 );
	   glColor3f( 0.0, 1.0, 0.0 );
       glVertex3f( 0.0, 0.0,0.0 );
       glVertex3f( 0.0, 0.5,0.0 );
	   glColor3f( 0.0, 0.0, 1.0 );
       glVertex3f( 0.0, 0.0,0.0 );
       glVertex3f( 0.0, 0.0,0.5 );
   glEnd();
}

GLvoid
drawScene( GLvoid )
{
   glClear( GL_COLOR_BUFFER_BIT );

   glPushMatrix();

    glRotatef( 10.0, 1.0, 0.0, 0.0 );
    glRotatef( -angle, 0.0, 1.0, 0.0 );
	glColor3f( 1.0, 1.0, 1.0 );
	glBegin(GL_LINE_LOOP);
		glVertex3f(-0.5, 0.0, 0.5);
		glVertex3f(0.5, 0.0, 0.5);
		glVertex3f(0.5, 0.0, -0.5);
		glVertex3f(-0.5, 0.0, -0.5);
	glEnd();	
	glBegin(GL_LINE_LOOP);
		glVertex3f(-0.5, 0.0, 0.5);
		glVertex3f(0.5, 0.0, 0.5);
		glVertex3f(0.0, 1.0, 0.0);
	glEnd();	
	glBegin(GL_LINE_LOOP);
		glVertex3f(0.5, 0.0, 0.5);
		glVertex3f(0.5, 0.0, -0.5);
		glVertex3f(0.0, 1.0, 0.0);
	glEnd();	
	glBegin(GL_LINE_LOOP);
		glVertex3f(0.5, 0.0, -0.5);
		glVertex3f(-0.5, 0.0, -0.5);
		glVertex3f(0.0, 1.0, 0.0);
	glEnd();	
	glBegin(GL_LINE_LOOP);
		glVertex3f(-0.5, 0.0, -0.5);
		glVertex3f(-0.5, 0.0, 0.5);
		glVertex3f(0.0, 1.0, 0.0);
	glEnd();
	XYaxes();

   glPopMatrix();

   glFlush();
}

